<?php
/*
Plugin Name: German Permalinks
Plugin URI: http://wordpress.org/#.
Description: Converts German umlauts to ASCII when sanitizing titles
Version: 1.2
Author: Scott Hanson
Author URI: http://www.papascott.de/
*/

function german_permalinks($title) {
  $german_chars['in'] =  array( chr(196), chr(228), chr(214), chr(246), chr(220), chr(252), chr(223));
  $german_chars['ecto'] =  array( '', '', '', '', '', '', '');
  $german_chars['out'] = array('Ae', 'ae', 'Oe', 'oe', 'Ue', 'ue', "ss");
  if (my_seems_utf8($title)) {
    $invalid_latin_chars = array(chr(197).chr(146) => 'OE', chr(197).chr(147) => 'oe', chr(197).chr(160) => 'S', chr(197).chr(189) => 'Z', chr(197).chr(161) => 's', chr(197).chr(190) => 'z', chr(226).chr(130).chr(172) => 'E');
    $title = utf8_decode(strtr($title, $invalid_latin_chars));
  }
  $title = str_replace($german_chars['ecto'], $german_chars['out'], $title);
  $title = str_replace($german_chars['in'], $german_chars['out'], $title);
  $title = sanitize_title_with_dashes($title);
  return $title;
}

# from CVS for 1.3, add 'my_' to function name to not conflict
function my_seems_utf8($Str) { # by bmorel at ssi dot fr
  for ($i=0; $i<strlen($Str); $i++) {
    if (ord($Str[$i]) < 0x80) continue; # 0bbbbbbb
    elseif ((ord($Str[$i]) & 0xE0) == 0xC0) $n=1; # 110bbbbb
    elseif ((ord($Str[$i]) & 0xF0) == 0xE0) $n=2; # 1110bbbb
    elseif ((ord($Str[$i]) & 0xF8) == 0xF0) $n=3; # 11110bbb
    elseif ((ord($Str[$i]) & 0xFC) == 0xF8) $n=4; # 111110bb
    elseif ((ord($Str[$i]) & 0xFE) == 0xFC) $n=5; # 1111110b
    else return false; # Does not match any model
    for ($j=0; $j<$n; $j++) { # n bytes matching 10bbbbbb follow ?
      if ((++$i == strlen($Str)) || ((ord($Str[$i]) & 0xC0) != 0x80))
      return false;
    }
  }
  return true;
}

remove_action('sanitize_title', 'sanitize_title_with_dashes');
add_action('sanitize_title', 'german_permalinks');

?>
