<?php

/*
Plugin Name: WP-AddQuicktag (de)
Version: 0.2
Plugin URI: http://bueltge.de/
Description: Dieses Plugin macht es einfach, Quicktags zum Editor hinzuzufuegen, ueber die <a href="options-general.php?page=wp-addquicktag.php">Optionen --> Add Quicktags</a> von WP. (Deutschsprachige Version: <a href="http://bueltge.de">bueltge.de</a>)
Author: Roel Meurders
Author URI: http://roel.meurders.nl/
Update:
*/

// SCRIPT INFO ///////////////////////////////////////////////////////////////////////////

/*
	WP-AddQuicktag for Wordpress
	(C) 2005 Roel Meurders - GNU General Public License
  
  Translate to German - Frank Bueltge

	This Wordpress plugin is released under a GNU General Public License. A complete version of this license
	can be found here: http://www.gnu.org/licenses/gpl.txt

	This Wordpress plugin has been tested with Wordpress 1.5.2 and Wordpress 2.0;

	This Wordpress plugin is released "as is". Without any warranty. The author cannot
	be held responsible for any damage that this script might cause.

*/

// NO EDITING HERE!!!!! ////////////////////////////////////////////////////////////////

	add_action('admin_menu', 'wpaq_admin_menu');

	function wpaq_admin_menu(){
		add_options_page('WP-Quicktag - Add Quicktags', 'Add Quicktags', 9, basename(__FILE__), 'wpaq_options_page');
	}

	function wpaq_options_page(){
		if ($_POST['wpaq']){
			$buttons = array();
			for ($i = 0; $i < count($_POST['wpaq']['buttons']); $i++){
				$b = $_POST['wpaq']['buttons'][$i];
				if ($b['text'] != '' && $b['start'] != ''){
					$b['text'] = htmlentities($b['text']);
					$b['start'] = stripslashes($b['start']);
					$b['end'] = stripslashes($b['end']);
					$buttons[] = $b;
				}
			}
			$_POST['wpaq']['buttons'] = $buttons;
			update_option('rmnlQuicktagSettings', $_POST['wpaq']);
			$message = '<div class="updated"><p><strong>Einstellungen gesichert.</strong></p></div>';
		}

		$o = get_option('rmnlQuicktagSettings');

		echo <<<EOT
		<div class="wrap">
			<h2>WP-Quicktag Management</h2>
			{$message}
			<form name="form1" method="post" action="options-general.php?page=wp-addquicktag.php">
			<fieldset class="options">
				<legend>Hinzuf&uuml;gen oder L&ouml;schen von Quicktag-Buttons</legend>
				<p>F&uuml;lle die unteren Felder aus, um Quicktags hinzuzuf&uuml;gen. Felder mit * sind Pflicht. Zum L&ouml;schen eines Quicktags einfach alle zugeh&ouml;rigen Felder l&ouml;schen.</p>
				<table width="100%" cellspacing="2" cellpadding="5" class="editform">
					<tr>
						<th style="text-align: center;">Buttontext*</th>
						<th style="text-align: center;">Start tag(s)*</th>
						<th style="text-align: center;">End tag(s)</th>
					</tr>
EOT;
		for ($i = 0; $i < count($o['buttons']); $i++){
			$b = $o['buttons'][$i];
			$nr = $i + 1;
			echo <<<EOT
					<tr valign="top" style="text-align: center;">
						<td><input type="text" name="wpaq[buttons][{$i}][text]" value="{$b['text']}" style="width: 95%;" /></td>
						<td><textarea name="wpaq[buttons][{$i}][start]" rows="2" cols="25" style="width: 95%;">{$b['start']}</textarea></td>
						<td><textarea name="wpaq[buttons][{$i}][end]" rows="2" cols="25" style="width: 95%;">{$b['end']}</textarea></td>
					</tr>
EOT;
		}
		echo <<<EOT
					<tr valign="top" style="text-align: center;">
						<td><input type="text" name="wpaq[buttons][{$i}][text]" value="" / style="width: 95%;"></td>
						<td><textarea name="wpaq[buttons][{$i}][start]" rows="2" cols="25" style="width: 95%;"></textarea></td>
						<td><textarea name="wpaq[buttons][{$i}][end]" rows="2" cols="25" style="width: 95%;"></textarea></td>
					</tr>
				</table>
			</fieldset>
			<p class="submit">
				<input type="submit" name="Submit" value="Einstellungen speichern &raquo;" />
			</p>
			</form>
		</div>
EOT;
	}

	if(strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php') ) {

		add_action('admin_footer', 'wpaq_addsome');

		function wpaq_addsome(){
			$o = get_option('rmnlQuicktagSettings');
			if(count($o['buttons']) > 0){
				echo <<<EOT
				<script type="text/javascript">
					<!--
						if(wpaqToolbar = document.getElementById("ed_toolbar")){
							var wpaqNr, wpaqBut, wpaqStart, wpaqEnd;
EOT;
				for ($i = 0; $i < count($o['buttons']); $i++){
					$b = $o['buttons'][$i];
					$start = preg_replace('![\n\r]+!', "\\n", $b['start']);
					$start = str_replace("'", "\'", $start);
					$end = preg_replace('![\n\r]+!', "\\n", $b['end']);
					$end = str_replace("'", "\'", $end);
					echo <<<EOT
							wpaqStart = '{$start}';
							wpaqEnd = '{$end}';
							wpaqNr = edButtons.length;
							edButtons[wpaqNr] = new edButton('ed_wpaq{$i}','{$b['txt']}',wpaqStart, wpaqEnd,'');
							var wpaqBut = wpaqToolbar.lastChild;
							while (wpaqBut.nodeType != 1){
								wpaqBut = wpaqBut.previousSibling;
							}
							wpaqBut = wpaqBut.cloneNode(true);
							wpaqToolbar.appendChild(wpaqBut);
							wpaqBut.value = '{$b['text']}';
							wpaqBut.title = wpaqNr;
							wpaqBut.onclick = function () {edInsertTag(edCanvas, parseInt(this.title));}
							wpaqBut.id = "ed_wpaq{$i}";
EOT;
				}
				echo <<<EOT
						}

					//-->
				</script>
EOT;
			}
		}
	}

?>